<navbar *ngIf="project" [current_project]="project.projectName"></navbar>

<div class="main">
	<h4 *ngIf="project"> Knowledge base : {{project.projectName}} </h4>
	<h5 *ngIf="project"><i>{{project.projectDesc}}</i></h5>
	<br>
	<div class="row">
	    <div class="input-group col-xs-offset-1 col-xs-10">
	        <input [(ngModel)]="nl_query" (keyup.enter)="getQueryResults(nl_query)" class="search-query form-control" placeholder="Enter a query..."/>
	        <span class="input-group-btn">
	            <button class="btn btn-danger" type="button" (click)="getQueryResults(nl_query)">
	                <span class="glyphicon glyphicon-search"></span>
	            </button>
	        </span>
	    </div>
	</div>

	<loading bsModal #loading="bs-modal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="mySmallModalLabel" aria-hidden="true" [message]="'your query is being processed'"></loading>

	<div class="col-xs-offset-1 col-xs-5">
		<div *ngIf="no_mappings"> 
			<br> Sorry, we don't know the answer... 
		</div>

		<div *ngIf="current_mapping">
			<br> <b> I understood </b>:
			<span [innerHTML]="current_mapping.generated_sentence"></span>
			<br>
			<b>Am I wrong </b> ? You can change or specify my interpretation in the right column. 
		</div>

		<div *ngIf="current_mapping && !no_mappings">
			<div *ngIf="current_mapping.answer">
				<br>
				<b>You were looking for : </b>
				<br>
				<li *ngIf="isAsk(current_mapping.answer)"> {{current_mapping.answer}} </li>
				<ul *ngIf="!isAsk(current_mapping.answer)">
					<li *ngFor="let answer of current_mapping.answer">
						<div *ngIf="answer.labels">
							<span *ngFor="let label of answer.labels">
								<a *ngIf="answer.uri" href="{{answer.uri}}"> {{label.label.value}} </a>
								<p *ngIf="!answer.uri"> {{label.label.value}} </p>
								<span *ngIf="label != answer.labels[answer.labels.length-1]">, </span>
							</span>
						</div>
					</li>
				</ul>
			</div>
		</div>
	</div>

	<br>
	<div *ngIf="mappings" class="list-group col-xs-offset-1 col-xs-4">
		<div class="scrollable">
			<div *ngFor="let mapping of mappings">
				<a (click)="getSparqlQuery(mapping)" class="list-group-item list-group-item-action">
					<b>Sentence</b> : 
					<span [innerHTML]="mapping.generated_sentence"></span> 
					<br>
					<span *ngIf="current_mapping.descriptiveSentence == mapping.descriptiveSentence">
						<b>Pivot query</b> : {{pivotQuery}} <br>
						<b>Relevance mark</b> : {{mapping.relevanceMark}} <br>
						<a (click)="$event.stopPropagation(); mapping.show_desc=!mapping.show_desc" class=""> Show mapping description</a>
						<span *ngIf="mapping.show_desc">
							<b>Mapping description</b> : <br>
							{{mapping.mappingDescription}}
						</span>
						<br>
						<b>Change specification level of variables</b> :
						<br>
						<div *ngFor="let gen of mapping.descriptiveSentence.generalisation | keys">
							<div *ngIf="gen != 'gen_levels'">
								<div>
									<nouislider (click)="$event.stopPropagation();" class="col-xs-6" [keyboard]="true" [min]="0" [max]="mapping.descriptiveSentence.generalisation.gen_levels[gen].max" [step]="1" [(ngModel)]="mapping.descriptiveSentence.generalisation.gen_levels[gen].current" (ngModelChange)="onGenChanged(mapping.descriptiveSentence.generalisation.gen_levels[gen].current, current_mapping, gen)"></nouislider>
									<br>
								</div>
								 {{mapping.descriptiveSentence.generalisation[gen]}}
								<span *ngIf="gen != mapping.descriptiveSentence.generalisation[gen][mapping.descriptiveSentence.generalisation[gen].length-1]">  </span>
							</div>
						</div>
					</span>
				</a>
			</div>
		</div>
	</div>
</div>